;; pass ranks from one process to another and calculate their sum

(load "conf.lisp")
(require :tebdol)

(use-package '(:sb-sys :mpi))

(defun mpi-pass (out prev next)
  (without-gcing
    (let ((request (mpi-issend-object out next))
	  (in (mpi-receive-object prev)))
      (mpi-wait request)
      in)))

(mpi-init)

(let* ((rank (mpi-comm-rank *mpi-comm-world*))
       (size (mpi-comm-size *mpi-comm-world*))
       (prev (mod (1- rank) size))
       (next (mod (1+ rank) size)))
  (if (zerop rank)
      (format t "There ~:[are ~a processes~;is ~a process~] running.~%" (eq size 1) size))
  (format t
	  "Sum of ranks in process ~a is ~a.~%"
	  rank
	  (loop
	     repeat size
	     for value = rank then (mpi-pass value prev next)
	     sum value)))

(mpi-finalize)
