(defpackage :gsl
  (:use :common-lisp :sb-alien)
  (:export :gsl-rng-type
	   :gsl-rng
	   :+gsl-rng-ranlxd2+
	   :*gsl-rng-default*
	   :*gsl-rng-default-seed*
	   :gsl-rng-alloc
	   :gsl-rng-set
	   :gsl-rng-free
	   :gsl-rng-env-setup
	   :gsl-ran-binomial))

(in-package :gsl)

(load-shared-object "libgslcblas.so.0")
(load-shared-object "libgsl.so.0")

(define-alien-type gsl-rng-type (struct nil))
(define-alien-type gsl-rng (struct nil))

(define-alien-variable ("gsl_rng_ranlxd2" +gsl-rng-ranlxd2+)
    (* gsl-rng-type))

(define-alien-variable ("gsl_rng_default" *gsl-rng-default*)
    (* gsl-rng-type))

(define-alien-variable ("gsl_rng_default_seed" *gsl-rng-default-seed*)
    unsigned-long)

(define-alien-routine gsl-rng-alloc (* gsl-rng)
  (type (* gsl-rng-type)))

(define-alien-routine gsl-rng-set void
  (r (* gsl-rng))
  (s unsigned-long))

(define-alien-routine gsl-rng-free void
  (r (* gsl-rng)))

(define-alien-routine gsl-rng-env-setup (* gsl-rng-type))

(define-alien-routine gsl-ran-binomial unsigned-int
  (r (* gsl-rng))
  (p double)
  (n unsigned-int))
